
#include "OpenGLCom.h"
#include <windows.h>
#include <videotexture.h>
#include <image.h>
#include <gltexture.h>

RunApp(LPSTR ,int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
int    Render(LONG fps);
GLuint CreateCube();
void   EnableTextCoordGen();
void   SetTextureMatrix();
void   BuildTexBaisMatrix();
void   MyResize();

GLuint  lfont;
GLuint  list_cube;
GLfloat g_scale=0.5;

char szAppTitle[]="ͶӰʾ";
char szClassName[]="ProjectVideo";
VIDEOIMAGE vTxt;

char szFile[MAX_PATH];
int g_isCube = TRUE;
int g_rotCube = TRUE;

double mTexBais[16];



char* ChooseFile()
{
	OPENFILENAME ofn; 
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "Ƶļ(*.avi;*.asf;*.mpeg;*.mpg)\0*.avi;*.asf;*.mpeg;*.mpg\0ļ(*.*)\0*.*\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	
	// Display the Open dialog box. 
	
	if (GetOpenFileName(&ofn)==TRUE) 
		return szFile;
	else
		return NULL;
}
RunApp(LPSTR CmdLine ,int sw_mode)
{
	if(strlen(CmdLine)>0)
	{
		strcpy(szFile,CmdLine);
	}
	else
		if(!ChooseFile())
		   return 0;

	glEnable(GL_CULL_FACE);

	CoInitialize(NULL);

    vTxt._type = VTT_SCALESIZE;


	while( FAILED (CreateVideoImage(szFile,&vTxt)) )
	{
	    if(MessageBox(NULL,"ƵļȷĲ.ѡļ","ѡ",MB_OKCANCEL)==IDCANCEL)
		      return 1;
		else
			if(!ChooseFile())
				return 1; 
	}

	if(MessageBox(NULL,"<<<ӭϵʾ>>>\n\n    ǷѡȫĻķʽ","ѡ",MB_OKCANCEL)==IDCANCEL)
		CreateNormalApp(sw_mode,0,0,600,600);
	else
		CreateExcApp(sw_mode); 
	InitOpenGL();


	//ƵļѾ򿪡Ѿ
	Sleep(100);
	RetriveVImageInfo(&vTxt);
	BuildVideoTexture(&vTxt);

	//ӳϢ
    EnableTextCoordGen();
    BuildTexBaisMatrix();
    SetTextureMatrix();


	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);


	list_cube=CreateCube(); 
	g_AppData.bIsActive=1;
	MyResize();
	MainLoop(Render);
    ReleaseVideoImage(&vTxt);
	CoUninitialize();

	glDeleteLists(list_cube,1);
	ReleaseGL();
	return 1;
}

void  MyResize()
{
    RECT rct;
	GetClientRect(g_AppData.hWnd,&rct);
	int w = rct.right  - rct.left;
	int h = rct.bottom - rct.top ;
	if(w<h)
	{
		glViewport(0,(h-w)/2,w,w);
	}
	else
	{
		glViewport((w-h)/2,0,h,h);
	}
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(30,w/(float)h,0.3,2000);
	//glOrtho(-100,100,-100,100,-500.0,500.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

}

void EnableTextCoordGen()
{
	float m[4][4]={  1,0,0,0,
		             0,1,0,0,
					 0,0,1,0,
					 0,0,0,1};

	glTexGend(GL_S,GL_TEXTURE_GEN_MODE,GL_EYE_LINEAR);
	glTexGenfv(GL_S,GL_EYE_PLANE,m[0]);
	glEnable(GL_TEXTURE_GEN_S);

	glTexGend(GL_T,GL_TEXTURE_GEN_MODE,GL_EYE_LINEAR);
	glTexGenfv(GL_T,GL_EYE_PLANE,m[1]);
	glEnable(GL_TEXTURE_GEN_T);

	glTexGend(GL_R,GL_TEXTURE_GEN_MODE,GL_EYE_LINEAR);
	glTexGenfv(GL_R,GL_EYE_PLANE,m[2]);
	glEnable(GL_TEXTURE_GEN_R);

	glTexGend(GL_Q,GL_TEXTURE_GEN_MODE,GL_EYE_LINEAR);
	glTexGenfv(GL_Q,GL_EYE_PLANE,m[3]);
	glEnable(GL_TEXTURE_GEN_Q);

	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
//	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_R,GL_CLAMP);
//	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_Q,GL_CLAMP);
}
void SetTextureMatrix()
{
	static float _lc = -0.1;
	static float _bc = -0.1;
	static float _lv = 0.003;
	static float _bv = 0.002;

	if(_lc < -0.2 || _lc > 0.1)
		   _lv *= -1;
	if(_bc < -0.4 || _bc > 0.1) 
		   _bv *= -1;
	_lc += _lv;
	_bc += _bv;

	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();
	glMultMatrixd(mTexBais);  


	//gluPerspective(120,1.0,0.3,200);
	glFrustum(_lc, _lc+ 0.4, _bc , _bc + 0.4,1,1000);
	gluLookAt(1,0,-100,0,0,0,0,-1,0);
	glMatrixMode(GL_MODELVIEW);

}

void BuildTexBaisMatrix()
{
	float sx = (float)vTxt._raw_size.width/vTxt._size.width;
	float sy = (float)vTxt._raw_size.height/vTxt._size.height;
	float dx = (float)(vTxt._size.width - vTxt._raw_size.width)/vTxt._size.width /  2.0 ;
	float dy = (float)(vTxt._size.height - vTxt._raw_size.height)/vTxt._size.height/  2.0;

	dx+=0.002;
	dy+=0.002;
	sy *=0.99;
	sx *=0.99;
	double m[16 ]=
	{   sx * 0.5 , 0        , 0    ,    0,
		0        , sy * 0.5 , 0    ,    0,
		0        , 0        , 1    ,    0,
		dx + 0.5 , dy + 0.5 , 0    ,    1
	};

	memcpy((void*)mTexBais,(void*)m,16*sizeof(double));
}

void CreateWall()
{
	glBegin(GL_QUADS);
		glColor4f(1.0,0.7,0.7,1.0);
		//glTexCoord2f(0,0);
		glVertex3f(-100,0,0);

		glColor4f(1.0,1.,0.7,1.0);
		//glTexCoord2f(1,0);
		glVertex3f(0,0,-100);

		glColor4f(1.0,0.4,1,1.0);
		//glTexCoord2f(1,1);
		glVertex3f(0,160,-100);

		glColor4f(1.0,1.0,1.0,1.0);
		//glTexCoord2f(0,1);
		glVertex3f(-100,160,0);
	glEnd();

	glBegin(GL_QUADS);
		glColor4f(0.7,0.3,0.3,1.0);
		//glTexCoord2f(0,0);
		glVertex3f(0,0,-100);

		glColor4f(0.7,0.7,0.3,1.0);
		//glTexCoord2f(1,0);
		glVertex3f(100,0,0);

		glColor4f(0.7,0.8,0.4,1.0);
		//glTexCoord2f(1,1);
		glVertex3f(100,160,0);

		glColor4f(0.8,0.8,0.8,1.0);
		//glTexCoord2f(0,1);
		glVertex3f(0,160,-100);
	glEnd();

		glBegin(GL_QUADS);
		glColor4f(0.8,0.5,0.5,1.0);
		//glTexCoord2f(0,0);
		glVertex3f(-100,0,0);

		glColor4f(0.8,0.8,0.5,1.0);
		//glTexCoord2f(1,0);
		glVertex3f(0,0,100);

		glColor4f(0.8,0.4,0.7,1.0);
		//glTexCoord2f(1,1);
		glVertex3f(100,0,0);

		glColor4f(0.8,0.8,0.8,1.0);
		//glTexCoord2f(0,1);
		glVertex3f(0,0,-100);
	glEnd();
}
static int zRot=0;
static int yRot=0;
static int xRot=0;
int Render(LONG fps)
{
	char buf[256];
	sprintf(buf,"Fps: %d video",fps);

	IMAGESIZE size;
	size.bits = 32;
	glEnable(GL_TEXTURE_2D);


	if( IsVideoComplete(&vTxt) == 1)
		SeekVideoPos(&vTxt,0);
    UpdateVideoTexture(&vTxt);
    SetTextureMatrix();

	if(g_rotCube)
	{
		yRot+= 1;
		yRot%=360;
		zRot+= 1 ;
		zRot%=360;
		xRot++;
		xRot%=360;
	}
	glPushMatrix();
	glMatrixMode(GL_MODELVIEW);


	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
    
	glLoadIdentity();
	//gluLookAt(0,0,100,0,0,-1,0,1,0);
	glTranslatef(0,-80,-380);
	glRotated(10,1,0,0);
	glRotated(10,0,1,0);

	CreateWall();


	glLoadIdentity();
	glTranslatef(0,0,-200);
	glScalef(g_scale,g_scale,g_scale);
	glRotated(zRot,0,0,1);
	glRotated(yRot,0,1,0);
	glRotated(xRot,1,0,0);
	glTranslatef(-50,-50,-50);

	if(g_isCube)
	{
		//glEnable(GL_BLEND);
		//glBlendFunc(GL_ONE_MINUS_SRC_COLOR,GL_SRC_COLOR);
		glCallList(list_cube);
	}


    glDisable(GL_BLEND);
	glPopMatrix();
	glColor3f(1,0,1);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
	BeginRenderFont();
	RenderFont("Project video Cube Demo ",-100,94);
	RenderFont("Panliliang Xheartblue Demo series",-100,84);
	RenderFont("Press F1 for Help",-100,74);
	RenderFont(buf,-100,-91);
    double t = GetVideoPos(&vTxt);
	sprintf(buf,"Current Time <%d : %d: %d>",(int)t/3600,(int(t)%3600)/60,((int)t%3600)%60);
    RenderFont(buf,-100,-85);
	EndRenderFont();
	SwapBuffers(g_AppData.hdc);
	glEnable(GL_DEPTH_TEST);
	return fps;
}
GLuint CreateCube()
{
	float v[6][3]=
	{
		    100,0,0,
			100,100,0,
			0,100,0,
			0,100,100,
			0,0,100,
			100,0,100
	};
	
	float c1[6][2]=
	{1,0,
		1,1,
		0,1,
		1,1,
		1,0,
		1,1
	};
	float c2[6][2]=
	{
	    	1,1,
			1,0,
			1,1,
			0,1,
			1,1,
			1,0,
			
	};	            
	//ָ
	int i;
	GLuint lCube=glGenLists(1);
	glNewList(lCube,GL_COMPILE);
	glBegin(GL_TRIANGLE_FAN);
	//glTexCoord2f(0,0);
	glColor3f(0,0,0);
	glVertex3f(0,0,0);
	for(i=0;i<6;i++)
	{
		glColor3fv(v[i]);
		//glTexCoord2f(c1[i][0],c1[i][1]);
		glVertex3fv(v[i]);
	}
	//glTexCoord2f(0,1);
	glColor3fv(v[0]);
	glVertex3fv(v[0]);
	glEnd();
	glBegin(GL_TRIANGLE_FAN);
	//glTexCoord2f(0,0);
	glColor3f(1,1,1);
	glVertex3f(100,100,100);
	for(i=5;i>=0;i--)
	{
		//glTexCoord2f(c2[i][0],c2[i][1]);
		glColor3fv(v[i]);
		glVertex3fv(v[i]);
	}
	//glTexCoord2f(0,1);
	glColor3fv(v[5]);
	glVertex3fv(v[5]);
	glEnd();
	glEndList();
	return lCube;
}
LRESULT CALLBACK	WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	double ct;
	double rate;
	switch(msg)
	{
	case WM_CREATE:
	case WM_SIZE:
		MyResize();
		break;
	case WM_KEYDOWN:
		switch(wParam)
		{
		case VK_F1:
			PauseVideo(&vTxt);
			MessageBox(hWnd,"    ===>ϵʾ<===    \n"\
				            "ģͶһһµƷ\n"\
							"    OpenGL --> Ok <--- DirectShow\n"\
							"         Project Video Player    \n"\
							"-------------------------------------\n"\
				            "       Escape : ˳\n"\
                            "       +      : Ŵ\n"\
							"       -      : С\n"\
                            "       Home   : ط\n"\
							"       Left   : \n"\
							"       Right  : ǰ\n"\
	                        "       Insert : \n"\
							"       Delete : \n"\
							"       F1     : \n"\
							"       F2     : \n"\
							"  w,a,s,d,z,x : ת\n"\
							"       r      : лת\n"\
							"-------------------------------------\n","",MB_OK);
            RunVideo(&vTxt);
			break;
		case VK_ESCAPE:
			PostQuitMessage(0);
			break;
		case VK_F2:
			g_isCube = !g_isCube;
			break;
		case VK_ADD:
			if(g_scale<2)
			   g_scale+=0.005;
			break;
		case VK_SUBTRACT:
			if(g_scale>0.1)
			   g_scale-=0.005;
			break;
		case VK_UP:
			break;
		case VK_HOME:
			SeekVideoPos(&vTxt,0);
			break;
		case VK_LEFT:
			ct = GetVideoPos(&vTxt);
			ct -= 3;
            if(ct<0)
				ct = 0;
			SeekVideoPos(&vTxt,ct);
			break;
		case VK_RIGHT:
			ct = GetVideoPos(&vTxt);
			ct += 3;
			SeekVideoPos(&vTxt,ct);
			break;
		case VK_INSERT:
			rate = ::GetVideoRate(&vTxt);
			rate *=1.5;
			::SetVideoRate(&vTxt,rate);
			break;
		case VK_DELETE:
			rate = ::GetVideoRate(&vTxt);
			rate /=1.5;
			::SetVideoRate(&vTxt,rate);
			break;

		}
		break;
		case WM_CHAR:
			switch(wParam)
			{
			case 'a':
				xRot --;
				xRot%=360;
				break;
			case 'd':
				xRot ++;
				xRot%=360;
				break;
			case 's':
				yRot--;
				yRot%=360;
				break;
			case 'w':
				yRot++;
				yRot%=360;
				break;
			case 'z':
				zRot --;
				zRot%=360;
				break;
			case 'x':
				zRot++;
				zRot%=360;
				break;
			case 'r':
				g_rotCube = ! g_rotCube;
				break;
			}
			break;
	case WM_CLOSE:
		DestroyWindow(hWnd);
		break;
	case WM_DESTROY:
        PostQuitMessage(0);
		break;
	default:
		return ::DefWindowProc(hWnd,msg,wParam,lParam); 
	}
	return 1;
	
}
